summaryrefslogtreecommitdiff
path: root/x11-libs/gtk+
diff options
context:
space:
mode:
authorV3n3RiX <venerix@redcorelinux.org>2018-04-02 19:36:21 +0100
committerV3n3RiX <venerix@redcorelinux.org>2018-04-02 19:36:21 +0100
commitc37e071dc436030e4d7c2c6c3108670b501a81ce (patch)
treed956e717db531bbfa0b8ad26af6ae9e6bf7aa522 /x11-libs/gtk+
parentffb107be125d840b7d13ff0c9dfc1e271d7d59b5 (diff)
x11-libs/gtk+ : import from gentoo tree, overwrite default settings
Diffstat (limited to 'x11-libs/gtk+')
-rw-r--r--x11-libs/gtk+/Manifest2
-rw-r--r--x11-libs/gtk+/files/gtk+-2.24.24-out-of-source.patch33
-rw-r--r--x11-libs/gtk+/files/gtk+-2.24.31-fix-gtkentry-beep.patch42
-rw-r--r--x11-libs/gtk+/files/gtk+-2.24.31-update-icon-cache.patch78
-rw-r--r--x11-libs/gtk+/files/gtk+-3.22.2-update-icon-cache.patch138
-rw-r--r--x11-libs/gtk+/files/gtkrc39
-rw-r--r--x11-libs/gtk+/files/gtkrc-2.015
-rw-r--r--x11-libs/gtk+/files/settings.ini16
-rw-r--r--x11-libs/gtk+/gtk+-2.24.31-r1337.ebuild303
-rw-r--r--x11-libs/gtk+/gtk+-3.22.19-r1337.ebuild226
10 files changed, 892 insertions, 0 deletions
diff --git a/x11-libs/gtk+/Manifest b/x11-libs/gtk+/Manifest
new file mode 100644
index 00000000..82cccd9d
--- /dev/null
+++ b/x11-libs/gtk+/Manifest
@@ -0,0 +1,2 @@
+DIST gtk+-2.24.31.tar.xz 12805344 BLAKE2B f516f9970a95afa21ae5dbe9f0cafd3c57c5cd27af0c6740a0f7f4367eb8032719e39e533bf89db72dddba7485ee499da9c2370707f51bbc4a7af2d4fb7c1309 SHA512 75b846661308d94b5236e7e1c367deabf57753792ca87e92f9769822dd5ec90e00cd8d5574adcc12162e3702e1ae6dc152278a1d218f9bd9e4d1c8dc1dd520c1
+DIST gtk+-3.22.19.tar.xz 18841024 BLAKE2B dc4c27d022c6766036b16e52b53b4aa3946c41457abaabca390bdba2b720db71b9c584101990928af1bef73dc49f7b71a951ba0000bd52e11aa5306a1d877f18 SHA512 c83198794433ee6eb29f8740d59bd7056cd36808b4bff1a99563ab1a1742e6635dab4f2a8be33317f74d3b336f0d1adc28dd91410da056b50a08c215f184dce2
diff --git a/x11-libs/gtk+/files/gtk+-2.24.24-out-of-source.patch b/x11-libs/gtk+/files/gtk+-2.24.24-out-of-source.patch
new file mode 100644
index 00000000..451233ca
--- /dev/null
+++ b/x11-libs/gtk+/files/gtk+-2.24.24-out-of-source.patch
@@ -0,0 +1,33 @@
+From 9e0f33144aff8d792ab105927cf686eda0afd25e Mon Sep 17 00:00:00 2001
+From: =?UTF-8?q?Micha=C5=82=20G=C3=B3rny?= <mgorny@gentoo.org>
+Date: Sun, 18 May 2014 10:50:05 +0200
+Subject: [PATCH] aliasfilecheck: check for sources both in builddir & srcdir.
+
+The $gtk_all_c_sources variable contains both supplied and generated
+sources. The former reside in $srcdir, the latter in the build directory
+(cwd).
+
+In order to handle both kinds properly, first try to find each source
+file in cwd, and then fallback to $srcdir. This makes it possible to use
+out-of-source builds, and guarantees that fresh-built source files will
+be used rather than pre-generated copies included in the distribution
+tarball.
+---
+ gtk/aliasfilescheck.sh | 2 +-
+ 1 file changed, 1 insertion(+), 1 deletion(-)
+
+diff --git a/gtk/aliasfilescheck.sh b/gtk/aliasfilescheck.sh
+index 31b49d4..3636a82 100755
+--- a/gtk/aliasfilescheck.sh
++++ b/gtk/aliasfilescheck.sh
+@@ -6,6 +6,6 @@ if test "x$gtk_all_c_sources" = x; then
+ fi
+
+ grep 'IN_FILE' ${srcdir-.}/gtk.symbols | sed 's/.*(//;s/).*//' | grep __ | sort -u > expected-files
+-{ cd ${srcdir-.}; grep '^ *# *define __' $gtk_all_c_sources; } | sed 's/.*define //;s/ *$//' | sort > actual-files
++{ for f in $gtk_all_c_sources; do if test -f ${f}; then grep '^ *# *define __' ${f}; else grep '^ *# *define __' "${srcdir-.}"/${f}; fi; done } | sed 's/.*define //;s/ *$//' | sort > actual-files
+
+ diff expected-files actual-files && rm -f expected-files actual-files
+--
+1.9.3
+
diff --git a/x11-libs/gtk+/files/gtk+-2.24.31-fix-gtkentry-beep.patch b/x11-libs/gtk+/files/gtk+-2.24.31-fix-gtkentry-beep.patch
new file mode 100644
index 00000000..1d09721b
--- /dev/null
+++ b/x11-libs/gtk+/files/gtk+-2.24.31-fix-gtkentry-beep.patch
@@ -0,0 +1,42 @@
+From debba4d14155a9e5736de069c2b693ab6f6e21aa Mon Sep 17 00:00:00 2001
+From: Matthias Clasen <mclasen@redhat.com>
+Date: Wed, 5 Oct 2016 12:20:14 -0400
+Subject: [PATCH] entry: Fix a corner case of overwrite mode
+
+We currently beep when a character is appended at the end in
+overwrite mode. That is obviously not right. Patch based on
+a patch by Ian MacDonald.
+
+https://bugzilla.gnome.org/show_bug.cgi?id=772389
+---
+ gtk/gtkentry.c | 7 ++++++-
+ 1 file changed, 6 insertions(+), 1 deletion(-)
+
+diff --git a/gtk/gtkentry.c b/gtk/gtkentry.c
+index b522039..bc33754 100644
+--- a/gtk/gtkentry.c
++++ b/gtk/gtkentry.c
+@@ -5224,6 +5224,7 @@ gtk_entry_enter_text (GtkEntry *entry,
+ GtkEditable *editable = GTK_EDITABLE (entry);
+ gint tmp_pos;
+ gboolean old_need_im_reset;
++ guint text_length;
+
+ old_need_im_reset = entry->need_im_reset;
+ entry->need_im_reset = FALSE;
+@@ -5233,7 +5234,11 @@ gtk_entry_enter_text (GtkEntry *entry,
+ else
+ {
+ if (entry->overwrite_mode)
+- gtk_entry_delete_from_cursor (entry, GTK_DELETE_CHARS, 1);
++ {
++ text_length = gtk_entry_buffer_get_length (get_buffer (entry));
++ if (entry->current_pos < text_length)
++ gtk_entry_delete_from_cursor (entry, GTK_DELETE_CHARS, 1);
++ }
+ }
+
+ tmp_pos = entry->current_pos;
+--
+2.10.0
+
diff --git a/x11-libs/gtk+/files/gtk+-2.24.31-update-icon-cache.patch b/x11-libs/gtk+/files/gtk+-2.24.31-update-icon-cache.patch
new file mode 100644
index 00000000..11dbb5e4
--- /dev/null
+++ b/x11-libs/gtk+/files/gtk+-2.24.31-update-icon-cache.patch
@@ -0,0 +1,78 @@
+From 260f94f3914ba18a256e6f1c222f643a57854e80 Mon Sep 17 00:00:00 2001
+From: Gilles Dartiguelongue <eva@gentoo.org>
+Date: Sat, 9 May 2015 23:30:58 +0200
+Subject: [PATCH] Always use external gtk-update-icon-cache
+
+---
+ configure.ac | 8 +++-----
+ docs/reference/gtk/Makefile.am | 2 +-
+ gtk/Makefile.am | 13 ++-----------
+ 3 files changed, 6 insertions(+), 17 deletions(-)
+
+diff --git a/configure.ac b/configure.ac
+index 4e11b40..7ef8cb6 100644
+--- a/configure.ac
++++ b/configure.ac
+@@ -913,11 +913,9 @@ dnl Look for a host system's gdk-pixbuf-csource if we are cross-compiling
+
+ AM_CONDITIONAL(CROSS_COMPILING, test $cross_compiling = yes)
+
+-if test $cross_compiling = yes; then
+- AC_PATH_PROG(GTK_UPDATE_ICON_CACHE, gtk-update-icon-cache, no)
+- if test x$GTK_UPDATE_ICON_CACHE = xno; then
+- REBUILD_PNGS=#
+- fi
++AC_PATH_PROG(GTK_UPDATE_ICON_CACHE, gtk-update-icon-cache, no)
++if test x$GTK_UPDATE_ICON_CACHE = xno; then
++ REBUILD_PNGS=#
+ fi
+
+ AC_PATH_PROG(GDK_PIXBUF_CSOURCE, gdk-pixbuf-csource, no)
+diff --git a/docs/reference/gtk/Makefile.am b/docs/reference/gtk/Makefile.am
+index c239445..60b5265 100644
+--- a/docs/reference/gtk/Makefile.am
++++ b/docs/reference/gtk/Makefile.am
+@@ -368,7 +368,7 @@ EXTRA_DIST += version.xml.in
+
+ if ENABLE_MAN
+
+-man_MANS = gtk-query-immodules-2.0.1 gtk-update-icon-cache.1 gtk-builder-convert.1
++man_MANS = gtk-query-immodules-2.0.1 gtk-builder-convert.1
+
+ %.1 : %.xml
+ @XSLTPROC@ -nonet http://docbook.sourceforge.net/release/xsl/current/manpages/docbook.xsl $<
+diff --git a/gtk/Makefile.am b/gtk/Makefile.am
+index 8cc4536..a7afbf3 100644
+--- a/gtk/Makefile.am
++++ b/gtk/Makefile.am
+@@ -1087,8 +1087,7 @@ endif
+ # Installed tools
+ #
+ bin_PROGRAMS = \
+- gtk-query-immodules-2.0 \
+- gtk-update-icon-cache
++ gtk-query-immodules-2.0
+
+ bin_SCRIPTS = gtk-builder-convert
+
+@@ -1438,16 +1437,8 @@ stamp-icons: $(STOCK_ICONS)
+ ) done \
+ && touch stamp-icons
+
+-if CROSS_COMPILING
+-gtk_update_icon_cache_program = $(GTK_UPDATE_ICON_CACHE)
+-else
+-gtk_update_icon_cache_program = \
+- ./gtk-update-icon-cache
+-endif
+-
+ gtkbuiltincache.h: @REBUILD@ stamp-icons
+- $(MAKE) $(AM_MAKEFLAGS) gtk-update-icon-cache$(EXEEXT)
+- $(gtk_update_icon_cache_program) --force --ignore-theme-index \
++ $(GTK_UPDATE_ICON_CACHE) --force --ignore-theme-index \
+ --include-image-data \
+ --source builtin_icons stock-icons > gtkbuiltincache.h.tmp && \
+ mv gtkbuiltincache.h.tmp gtkbuiltincache.h
+--
+2.10.0
+
diff --git a/x11-libs/gtk+/files/gtk+-3.22.2-update-icon-cache.patch b/x11-libs/gtk+/files/gtk+-3.22.2-update-icon-cache.patch
new file mode 100644
index 00000000..fc1e86e9
--- /dev/null
+++ b/x11-libs/gtk+/files/gtk+-3.22.2-update-icon-cache.patch
@@ -0,0 +1,138 @@
+From 101b43f4a38904ee21070a3e2eb5ba03dfe17647 Mon Sep 17 00:00:00 2001
+From: Gilles Dartiguelongue <eva@gentoo.org>
+Date: Tue, 1 Nov 2016 15:24:22 +0100
+Subject: [PATCH] Always use external gtk-update-icon-cache
+
+Check for gtk-update-icon-cache to install demos, otherwise it is not
+used when building.
+---
+ configure.ac | 2 ++
+ demos/gtk-demo/Makefile.am | 2 +-
+ demos/widget-factory/Makefile.am | 2 +-
+ docs/reference/gtk/Makefile.am | 1 -
+ gtk/Makefile.am | 44 ----------------------------------------
+ 5 files changed, 4 insertions(+), 47 deletions(-)
+
+diff --git a/configure.ac b/configure.ac
+index 4f9f183..ecf99dc 100644
+--- a/configure.ac
++++ b/configure.ac
+@@ -999,6 +999,8 @@ dnl Look for a host system's gdk-pixbuf-csource if we are cross-compiling
+
+ AM_CONDITIONAL(CROSS_COMPILING, test $cross_compiling = yes)
+
++AC_PATH_PROG(GTK_UPDATE_ICON_CACHE, [gtk-update-icon-cache], [no])
++
+ ########################################
+ # Windowing system checks
+ ########################################
+diff --git a/demos/gtk-demo/Makefile.am b/demos/gtk-demo/Makefile.am
+index 8c15e16..5d774d2 100644
+--- a/demos/gtk-demo/Makefile.am
++++ b/demos/gtk-demo/Makefile.am
+@@ -171,7 +171,7 @@ dist_appsicon32_DATA = data/32x32/gtk3-demo.png data/32x32/gtk3-demo-symbolic.sy
+ dist_appsicon48_DATA = data/48x48/gtk3-demo.png data/48x48/gtk3-demo-symbolic.symbolic.png
+ dist_appsicon256_DATA = data/256x256/gtk3-demo.png data/256x256/gtk3-demo-symbolic.symbolic.png
+
+-update_icon_cache = $(top_builddir)/gtk/gtk-update-icon-cache$(EXEEXT) --ignore-theme-index --force
++update_icon_cache = $(GTK_UPDATE_ICON_CACHE) --ignore-theme-index --force
+
+ install-data-hook: install-update-icon-cache
+ uninstall-hook: uninstall-update-icon-cache
+diff --git a/demos/widget-factory/Makefile.am b/demos/widget-factory/Makefile.am
+index a6bfbdc..28a3be2 100644
+--- a/demos/widget-factory/Makefile.am
++++ b/demos/widget-factory/Makefile.am
+@@ -47,7 +47,7 @@ dist_appsicon32_DATA = data/32x32/gtk3-widget-factory.png data/32x32/gtk3-widget
+ dist_appsicon48_DATA = data/48x48/gtk3-widget-factory.png data/48x48/gtk3-widget-factory-symbolic.symbolic.png
+ dist_appsicon256_DATA = data/256x256/gtk3-widget-factory.png data/256x256/gtk3-widget-factory-symbolic.symbolic.png
+
+-update_icon_cache = $(top_builddir)/gtk/gtk-update-icon-cache$(EXEEXT) --ignore-theme-index --force
++update_icon_cache = $(GTK_UPDATE_ICON_CACHE) --ignore-theme-index --force
+
+ install-data-hook: install-update-icon-cache
+ uninstall-hook: uninstall-update-icon-cache
+diff --git a/docs/reference/gtk/Makefile.am b/docs/reference/gtk/Makefile.am
+index 5a88a12..b51f3ac 100644
+--- a/docs/reference/gtk/Makefile.am
++++ b/docs/reference/gtk/Makefile.am
+@@ -504,7 +504,6 @@ EXTRA_DIST += version.xml.in gtk3.types.in
+
+ man_MANS = \
+ gtk-query-immodules-3.0.1 \
+- gtk-update-icon-cache.1 \
+ gtk-encode-symbolic-svg.1 \
+ gtk-launch.1 \
+ gtk3-demo.1 \
+diff --git a/gtk/Makefile.am b/gtk/Makefile.am
+index 3b76b82..d4c5681 100644
+--- a/gtk/Makefile.am
++++ b/gtk/Makefile.am
+@@ -1581,7 +1581,6 @@ endif
+ #
+ bin_PROGRAMS = \
+ gtk-query-immodules-3.0 \
+- gtk-update-icon-cache \
+ gtk-encode-symbolic-svg \
+ gtk-builder-tool \
+ gtk-query-settings \
+@@ -1594,9 +1593,6 @@ gtk_query_immodules_3_0_LDADD = \
+ $(GMODULE_LIBS) \
+ $(GTK_DEP_LIBS)
+
+-gtk_update_icon_cache_SOURCES = updateiconcache.c
+-gtk_update_icon_cache_LDADD = $(GDK_PIXBUF_LIBS)
+-
+ gtk_encode_symbolic_svg_SOURCES = encodesymbolic.c
+ gtk_encode_symbolic_svg_LDADD = \
+ $(GDK_PIXBUF_LIBS) \
+@@ -1621,46 +1617,6 @@ gtk_launch_LDADD = \
+ $(top_builddir)/gdk/libgdk-3.la \
+ $(GTK_DEP_LIBS)
+
+-if OS_WIN32
+-
+-# Workaround for UAC silliness: programs with "update" in their name
+-# are believed to be installers and require elevated privileges to be
+-# used... Embed a manifest file into executable to tell Windows that
+-# gtk-update-icon-cache.exe doesn't require any special privileges.
+-
+-GTK_UPDATE_ICON_CACHE_MANIFEST = gtk-update-icon-cache.exe.manifest
+-GTK_UPDATE_ICON_CACHE_RC = gtk-update-icon-cache.rc
+-GTK_UPDATE_ICON_CACHE_MANIFEST_OBJECT = gtk-update-icon-cache_manifest.o
+-
+-$(GTK_UPDATE_ICON_CACHE_MANIFEST):
+- (echo '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>' ; \
+- echo '<assembly xmlns="urn:schemas-microsoft-com:asm.v1" manifestVersion="1.0">' ; \
+- echo ' <assemblyIdentity version="1.0.0.0"' ; \
+- echo ' processorArchitecture="'$(EXE_MANIFEST_ARCHITECTURE)'"' ; \
+- echo ' name="gtk-update-icon-cache.exe"' ; \
+- echo ' type="win32"/>' ; \
+- echo ' <!-- Identify the application security requirements. -->' ; \
+- echo ' <trustInfo xmlns="urn:schemas-microsoft-com:asm.v3">' ; \
+- echo ' <security>' ; \
+- echo ' <requestedPrivileges>' ; \
+- echo ' <requestedExecutionLevel' ; \
+- echo ' level="asInvoker"' ; \
+- echo ' uiAccess="false"/>' ; \
+- echo ' </requestedPrivileges>' ; \
+- echo ' </security>' ; \
+- echo ' </trustInfo>' ; \
+- echo '</assembly>' ) >$@
+-
+-$(GTK_UPDATE_ICON_CACHE_RC):
+- (echo 'CREATEPROCESS_MANIFEST_RESOURCE_ID RT_MANIFEST '$(GTK_UPDATE_ICON_CACHE_MANIFEST)) >$@
+-
+-$(GTK_UPDATE_ICON_CACHE_MANIFEST_OBJECT): $(GTK_UPDATE_ICON_CACHE_RC) $(GTK_UPDATE_ICON_CACHE_MANIFEST)
+- $(WINDRES) --input $< --output $@ --output-format=coff
+-
+-gtk_update_icon_cache_LDADD += $(GTK_UPDATE_ICON_CACHE_MANIFEST_OBJECT)
+-
+-endif
+-
+ .PHONY: files
+
+ files:
+--
+2.10.1
+
diff --git a/x11-libs/gtk+/files/gtkrc b/x11-libs/gtk+/files/gtkrc
new file mode 100644
index 00000000..8d178343
--- /dev/null
+++ b/x11-libs/gtk+/files/gtkrc
@@ -0,0 +1,39 @@
+style "default"
+
+{
+ font = "-*-lucida-medium-r-normal-*-*-100-*-*-*-*-*-*"
+}
+
+style "button" = "default"
+
+{
+ bg[PRELIGHT] = { 0.7, 0.7, 0.9 }
+}
+
+style "treeitem"
+{
+bg[ACTIVE] = { 0.7, 0.7, 0.9 }
+}
+
+style "scrollbar" = "button"
+{
+ bg[ACTIVE] = {0.6, 0.6, 0.6 }
+}
+
+style "status" {
+ bg[PRELIGHT] = { 0.3, 1.0, 0.3 }
+}
+
+style "gtk-tooltips" {
+ bg[NORMAL] = "#ffff60"
+}
+
+class "GtkWidget" style "default"
+class "GtkButton" style "button"
+class "GtkItem" style "button"
+class "GtkProgressBar" style "status"
+class "GtkScrollbar" style "scrollbar"
+class "GtkTreeItem" style "treeitem"
+widget "gtk-tooltips" style "gtk-tooltips"
+
+
diff --git a/x11-libs/gtk+/files/gtkrc-2.0 b/x11-libs/gtk+/files/gtkrc-2.0
new file mode 100644
index 00000000..46e58525
--- /dev/null
+++ b/x11-libs/gtk+/files/gtkrc-2.0
@@ -0,0 +1,15 @@
+gtk-theme-name="Redcore-nighttime"
+gtk-icon-theme-name="material-design-dark"
+gtk-font-name="Roboto 9"
+gtk-cursor-theme-name="Hacked-Red"
+gtk-cursor-theme-size=0
+gtk-toolbar-style=GTK_TOOLBAR_ICONS
+gtk-toolbar-icon-size=GTK_ICON_SIZE_SMALL_TOOLBAR
+gtk-button-images=1
+gtk-menu-images=1
+gtk-enable-event-sounds=1
+gtk-enable-input-feedback-sounds=1
+gtk-xft-antialias=1
+gtk-xft-hinting=1
+gtk-xft-hintstyle="hintfull"
+gtk-xft-rgba="rgb"
diff --git a/x11-libs/gtk+/files/settings.ini b/x11-libs/gtk+/files/settings.ini
new file mode 100644
index 00000000..cb18b0af
--- /dev/null
+++ b/x11-libs/gtk+/files/settings.ini
@@ -0,0 +1,16 @@
+[Settings]
+gtk-theme-name=Redcore-nighttime
+gtk-icon-theme-name=material-design-dark
+gtk-font-name=Roboto 9
+gtk-cursor-theme-size=0
+gtk-toolbar-style=GTK_TOOLBAR_ICONS
+gtk-toolbar-icon-size=GTK_ICON_SIZE_SMALL_TOOLBAR
+gtk-button-images=1
+gtk-menu-images=1
+gtk-enable-event-sounds=1
+gtk-enable-input-feedback-sounds=1
+gtk-xft-antialias=1
+gtk-xft-hinting=1
+gtk-xft-hintstyle=hintfull
+gtk-xft-rgba=rgb
+gtk-cursor-theme-name=Hacked-Red
diff --git a/x11-libs/gtk+/gtk+-2.24.31-r1337.ebuild b/x11-libs/gtk+/gtk+-2.24.31-r1337.ebuild
new file mode 100644
index 00000000..37b52316
--- /dev/null
+++ b/x11-libs/gtk+/gtk+-2.24.31-r1337.ebuild
@@ -0,0 +1,303 @@
+# Copyright 1999-2017 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=6
+GNOME2_LA_PUNT="yes"
+
+inherit autotools eutils flag-o-matic gnome2 multilib multilib-minimal readme.gentoo-r1 virtualx
+
+DESCRIPTION="Gimp ToolKit +"
+HOMEPAGE="https://www.gtk.org/"
+
+LICENSE="LGPL-2+"
+SLOT="2"
+IUSE="aqua cups examples +introspection test vim-syntax xinerama"
+REQUIRED_USE="
+ xinerama? ( !aqua )
+"
+
+KEYWORDS="alpha amd64 arm ~arm64 hppa ia64 ~mips ppc ppc64 ~s390 ~sh sparc x86 ~amd64-fbsd ~x86-fbsd ~amd64-linux ~arm-linux ~x86-linux ~ppc-macos ~x64-macos ~x86-macos ~sparc-solaris ~sparc64-solaris ~x64-solaris ~x86-solaris"
+
+# Upstream wants us to do their job:
+# https://bugzilla.gnome.org/show_bug.cgi?id=768663#c1
+RESTRICT="test"
+
+COMMON_DEPEND="
+ >=dev-libs/atk-2.10.0[introspection?,${MULTILIB_USEDEP}]
+ >=dev-libs/glib-2.34.3:2[${MULTILIB_USEDEP}]
+ >=media-libs/fontconfig-2.10.92[${MULTILIB_USEDEP}]
+ >=x11-libs/cairo-1.12.14-r4:=[aqua?,svg,${MULTILIB_USEDEP}]
+ >=x11-libs/gdk-pixbuf-2.30.7:2[introspection?,${MULTILIB_USEDEP}]
+ >=x11-libs/pango-1.36.3[introspection?,${MULTILIB_USEDEP}]
+ x11-misc/shared-mime-info
+
+ cups? ( >=net-print/cups-1.7.1-r2:=[${MULTILIB_USEDEP}] )
+ introspection? ( >=dev-libs/gobject-introspection-0.9.3:= )
+ !aqua? (
+ >=x11-libs/cairo-1.12.14-r4:=[aqua?,svg,X,${MULTILIB_USEDEP}]
+ >=x11-libs/libXrender-0.9.8[${MULTILIB_USEDEP}]
+ >=x11-libs/libX11-1.6.2[${MULTILIB_USEDEP}]
+ >=x11-libs/libXi-1.7.2[${MULTILIB_USEDEP}]
+ >=x11-libs/libXext-1.3.2[${MULTILIB_USEDEP}]
+ >=x11-libs/libXrandr-1.5[${MULTILIB_USEDEP}]
+ >=x11-libs/libXcursor-1.1.14[${MULTILIB_USEDEP}]
+ >=x11-libs/libXfixes-5.0.1[${MULTILIB_USEDEP}]
+ >=x11-libs/libXcomposite-0.4.4-r1[${MULTILIB_USEDEP}]
+ >=x11-libs/libXdamage-1.1.4-r1[${MULTILIB_USEDEP}]
+ xinerama? ( >=x11-libs/libXinerama-1.1.3[${MULTILIB_USEDEP}] )
+ )
+"
+# docbook-4.1.2 and xsl required for man pages
+# docbook-4.3 required for gtk-doc
+DEPEND="${COMMON_DEPEND}
+ app-text/docbook-xsl-stylesheets
+ app-text/docbook-xml-dtd:4.1.2
+ app-text/docbook-xml-dtd:4.3
+ dev-libs/libxslt
+ dev-libs/gobject-introspection-common
+ >=dev-util/gtk-doc-am-1.20
+ >=sys-devel/gettext-0.18.3[${MULTILIB_USEDEP}]
+ >=virtual/pkgconfig-0-r1[${MULTILIB_USEDEP}]
+ !aqua? (
+ >=x11-proto/xextproto-7.2.1-r1[${MULTILIB_USEDEP}]
+ >=x11-proto/xproto-7.0.24[${MULTILIB_USEDEP}]
+ >=x11-proto/inputproto-2.3[${MULTILIB_USEDEP}]
+ >=x11-proto/damageproto-1.2.1-r1[${MULTILIB_USEDEP}]
+ xinerama? ( >=x11-proto/xineramaproto-1.2.1-r1[${MULTILIB_USEDEP}] )
+ )
+ test? (
+ x11-themes/hicolor-icon-theme
+ media-fonts/font-misc-misc
+ media-fonts/font-cursor-misc )
+"
+
+# gtk+-2.24.8 breaks Alt key handling in <=x11-libs/vte-0.28.2:0
+# Add blocker against old gtk-builder-convert to be sure we maintain both
+# in sync.
+RDEPEND="${COMMON_DEPEND}
+ >=dev-util/gtk-update-icon-cache-2
+ !<gnome-base/gail-1000
+ !<dev-util/gtk-builder-convert-${PV}
+ !<x11-libs/vte-0.28.2-r201:0
+ >=x11-themes/adwaita-icon-theme-3.14
+ x11-themes/gnome-themes-standard
+"
+# librsvg for svg icons (PDEPEND to avoid circular dep), bug #547710
+PDEPEND="
+ x11-themes/gtk-engines-adwaita
+ gnome-base/librsvg[${MULTILIB_USEDEP}]
+ vim-syntax? ( app-vim/gtk-syntax )
+"
+
+DISABLE_AUTOFORMATTING="yes"
+DOC_CONTENTS="To make the gtk2 file chooser use 'current directory' mode by default,
+edit ~/.config/gtk-2.0/gtkfilechooser.ini to contain the following:
+[Filechooser Settings]
+StartupMode=cwd"
+
+MULTILIB_CHOST_TOOLS=(
+ /usr/bin/gtk-query-immodules-2.0$(get_exeext)
+)
+
+strip_builddir() {
+ local rule=$1
+ shift
+ local directory=$1
+ shift
+ sed -e "s/^\(${rule} =.*\)${directory}\(.*\)$/\1\2/" -i $@ \
+ || die "Could not strip director ${directory} from build."
+}
+
+set_gtk2_confdir() {
+ # An arch specific config directory is used on multilib systems
+ GTK2_CONFDIR="/etc/gtk-2.0/${CHOST}"
+}
+
+src_prepare() {
+ # marshalers code was pre-generated with glib-2.31, upstream bug #662109
+ rm -v gdk/gdkmarshalers.c gtk/gtkmarshal.c gtk/gtkmarshalers.c \
+ perf/marshalers.c || die
+
+ # Stop trying to build unmaintained docs, bug #349754, upstream bug #623150
+ strip_builddir SUBDIRS tutorial docs/Makefile.{am,in}
+ strip_builddir SUBDIRS faq docs/Makefile.{am,in}
+
+ # -O3 and company cause random crashes in applications, bug #133469
+ replace-flags -O3 -O2
+ strip-flags
+
+ if ! use test ; then
+ # don't waste time building tests
+ strip_builddir SRC_SUBDIRS tests Makefile.{am,in}
+ strip_builddir SUBDIRS tests gdk/Makefile.{am,in} gtk/Makefile.{am,in}
+ else
+ # Non-working test in gentoo's env
+ sed 's:\(g_test_add_func ("/ui-tests/keys-events.*\):/*\1*/:g' \
+ -i gtk/tests/testing.c || die "sed 1 failed"
+
+ # Cannot work because glib is too clever to find real user's home
+ # gentoo bug #285687, upstream bug #639832
+ # XXX: /!\ Pay extra attention to second sed when bumping /!\
+ sed '/TEST_PROGS.*recentmanager/d' -i gtk/tests/Makefile.am \
+ || die "failed to disable recentmanager test (1)"
+ sed '/^TEST_PROGS =/,+3 s/recentmanager//' -i gtk/tests/Makefile.in \
+ || die "failed to disable recentmanager test (2)"
+ sed 's:\({ "GtkFileChooserButton".*},\):/*\1*/:g' -i gtk/tests/object.c \
+ || die "failed to disable recentmanager test (3)"
+
+ # https://bugzilla.gnome.org/show_bug.cgi?id=617473
+ sed -i -e 's:pltcheck.sh:$(NULL):g' \
+ gtk/Makefile.am || die
+
+ # UI tests require immodules already installed; bug #413185
+ if ! has_version 'x11-libs/gtk+:2'; then
+ ewarn "Disabling UI tests because this is the first install of"
+ ewarn "gtk+:2 on this machine. Please re-run the tests after $P"
+ ewarn "has been installed."
+ sed '/g_test_add_func.*ui-tests/ d' \
+ -i gtk/tests/testing.c || die "sed 2 failed"
+ fi
+ fi
+
+ if ! use examples; then
+ # don't waste time building demos
+ strip_builddir SRC_SUBDIRS demos Makefile.{am,in}
+ fi
+
+ # Fix tests running when building out of sources, bug #510596, upstream bug #730319
+ eapply "${FILESDIR}"/${PN}-2.24.24-out-of-source.patch
+
+ # Rely on split gtk-update-icon-cache package, bug #528810
+ eapply "${FILESDIR}"/${PN}-2.24.31-update-icon-cache.patch
+
+ # Fix beep when overwriting at the end of a gtkentry, from gtk-2-24 branch
+ eapply "${FILESDIR}"/${PN}-2.24.31-fix-gtkentry-beep.patch
+
+ eautoreconf
+ gnome2_src_prepare
+}
+
+multilib_src_configure() {
+ [[ ${ABI} == ppc64 ]] && append-flags -mminimal-toc
+
+ ECONF_SOURCE=${S} \
+ gnome2_src_configure \
+ $(usex aqua --with-gdktarget=quartz --with-gdktarget=x11) \
+ $(usex aqua "" --with-xinput) \
+ $(use_enable cups cups auto) \
+ $(multilib_native_use_enable introspection) \
+ $(use_enable xinerama) \
+ --disable-papi \
+ --enable-man \
+ --with-xml-catalog="${EPREFIX}"/etc/xml/catalog \
+ CUPS_CONFIG="${EPREFIX}/usr/bin/${CHOST}-cups-config"
+
+ # work-around gtk-doc out-of-source brokedness
+ if multilib_is_native_abi; then
+ local d
+ for d in gdk gtk libgail-util; do
+ ln -s "${S}"/docs/reference/${d}/html docs/reference/${d}/html || die
+ done
+ fi
+}
+
+multilib_src_test() {
+ virtx emake check
+}
+
+multilib_src_install() {
+ gnome2_src_install
+}
+
+multilib_src_install_all() {
+ insinto /usr/share/gtk-2.0
+ newins "${FILESDIR}"/gtkrc-2.0 gtkrc
+
+ einstalldocs
+
+ # dev-util/gtk-builder-convert split off into a separate package, #402905
+ rm "${ED}"usr/bin/gtk-builder-convert || die
+ rm "${ED}"usr/share/man/man1/gtk-builder-convert.* || die
+
+ readme.gentoo_create_doc
+}
+
+pkg_preinst() {
+ gnome2_pkg_preinst
+
+ multilib_pkg_preinst() {
+ # Make immodules.cache belongs to gtk+ alone
+ local cache="usr/$(get_libdir)/gtk-2.0/2.10.0/immodules.cache"
+
+ if [[ -e ${EROOT}${cache} ]]; then
+ cp "${EROOT}"${cache} "${ED}"/${cache} || die
+ else
+ touch "${ED}"/${cache} || die
+ fi
+ }
+ multilib_parallel_foreach_abi multilib_pkg_preinst
+}
+
+pkg_postinst() {
+ gnome2_pkg_postinst
+
+ multilib_pkg_postinst() {
+ gnome2_query_immodules_gtk2 \
+ || die "Update immodules cache failed (for ${ABI})"
+ }
+ multilib_parallel_foreach_abi multilib_pkg_postinst
+
+ set_gtk2_confdir
+
+ if [ -e "${EROOT%/}/etc/gtk-2.0/gtk.immodules" ]; then
+ elog "File /etc/gtk-2.0/gtk.immodules has been moved to \$CHOST"
+ elog "aware location. Removing deprecated file."
+ rm -f ${EROOT%/}/etc/gtk-2.0/gtk.immodules
+ fi
+
+ if [ -e "${EROOT%/}${GTK2_CONFDIR}/gtk.immodules" ]; then
+ elog "File /etc/gtk-2.0/gtk.immodules has been moved to"
+ elog "${EROOT%/}/usr/$(get_libdir)/gtk-2.0/2.10.0/immodules.cache"
+ elog "Removing deprecated file."
+ rm -f ${EROOT%/}${GTK2_CONFDIR}/gtk.immodules
+ fi
+
+ # pixbufs are now handled by x11-libs/gdk-pixbuf
+ if [ -e "${EROOT%/}${GTK2_CONFDIR}/gdk-pixbuf.loaders" ]; then
+ elog "File ${EROOT%/}${GTK2_CONFDIR}/gdk-pixbuf.loaders is now handled by x11-libs/gdk-pixbuf"
+ elog "Removing deprecated file."
+ rm -f ${EROOT%/}${GTK2_CONFDIR}/gdk-pixbuf.loaders
+ fi
+
+ # two checks needed since we dropped multilib conditional
+ if [ -e "${EROOT%/}/etc/gtk-2.0/gdk-pixbuf.loaders" ]; then
+ elog "File ${EROOT%/}/etc/gtk-2.0/gdk-pixbuf.loaders is now handled by x11-libs/gdk-pixbuf"
+ elog "Removing deprecated file."
+ rm -f ${EROOT%/}/etc/gtk-2.0/gdk-pixbuf.loaders
+ fi
+
+ if [ -e "${EROOT%/}"/usr/lib/gtk-2.0/2.[^1]* ]; then
+ elog "You need to rebuild ebuilds that installed into" "${EROOT%/}"/usr/lib/gtk-2.0/2.[^1]*
+ elog "to do that you can use qfile from portage-utils:"
+ elog "emerge -va1 \$(qfile -qC ${EPREFIX}/usr/lib/gtk-2.0/2.[^1]*)"
+ fi
+
+ if ! has_version "app-text/evince"; then
+ elog "Please install app-text/evince for print preview functionality."
+ elog "Alternatively, check \"gtk-print-preview-command\" documentation and"
+ elog "add it to your gtkrc."
+ fi
+
+ readme.gentoo_print_elog
+}
+
+pkg_postrm() {
+ gnome2_pkg_postrm
+
+ if [[ -z ${REPLACED_BY_VERSION} ]]; then
+ multilib_pkg_postrm() {
+ rm -f "${EROOT}"usr/$(get_libdir)/gtk-2.0/2.10.0/immodules.cache
+ }
+ multilib_foreach_abi multilib_pkg_postrm
+ fi
+}
diff --git a/x11-libs/gtk+/gtk+-3.22.19-r1337.ebuild b/x11-libs/gtk+/gtk+-3.22.19-r1337.ebuild
new file mode 100644
index 00000000..5cfe545d
--- /dev/null
+++ b/x11-libs/gtk+/gtk+-3.22.19-r1337.ebuild
@@ -0,0 +1,226 @@
+# Copyright 1999-2017 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=6
+GNOME2_LA_PUNT="yes"
+
+inherit autotools flag-o-matic gnome2 multilib virtualx multilib-minimal
+
+DESCRIPTION="Gimp ToolKit +"
+HOMEPAGE="https://www.gtk.org/"
+
+LICENSE="LGPL-2+"
+SLOT="3"
+IUSE="aqua broadway cloudprint colord cups examples +introspection test vim-syntax wayland +X xinerama"
+REQUIRED_USE="
+ || ( aqua wayland X )
+ xinerama? ( X )
+"
+
+KEYWORDS="alpha amd64 arm ~arm64 hppa ia64 ~mips ppc ppc64 ~s390 ~sh sparc x86 ~amd64-fbsd ~x86-fbsd ~amd64-linux ~arm-linux ~x86-linux ~ppc-macos ~x86-macos ~sparc-solaris ~sparc64-solaris ~x64-solaris ~x86-solaris"
+
+# Upstream wants us to do their job:
+# https://bugzilla.gnome.org/show_bug.cgi?id=768662#c1
+RESTRICT="test"
+
+# FIXME: introspection data is built against system installation of gtk+:3,
+# bug #????
+COMMON_DEPEND="
+ >=dev-libs/atk-2.15[introspection?,${MULTILIB_USEDEP}]
+ >=dev-libs/glib-2.49.4:2[${MULTILIB_USEDEP}]
+ media-libs/fontconfig[${MULTILIB_USEDEP}]
+ >=media-libs/libepoxy-1.0[X(+)?,${MULTILIB_USEDEP}]
+ >=x11-libs/cairo-1.14[aqua?,glib,svg,X?,${MULTILIB_USEDEP}]
+ >=x11-libs/gdk-pixbuf-2.30:2[introspection?,${MULTILIB_USEDEP}]
+ >=x11-libs/pango-1.37.3[introspection?,${MULTILIB_USEDEP}]
+ x11-misc/shared-mime-info
+
+ cloudprint? (
+ >=net-libs/rest-0.7[${MULTILIB_USEDEP}]
+ >=dev-libs/json-glib-1.0[${MULTILIB_USEDEP}] )
+ colord? ( >=x11-misc/colord-0.1.9:0=[${MULTILIB_USEDEP}] )
+ cups? ( >=net-print/cups-1.2[${MULTILIB_USEDEP}] )
+ introspection? ( >=dev-libs/gobject-introspection-1.39:= )
+ wayland? (
+ >=dev-libs/wayland-1.9.91[${MULTILIB_USEDEP}]
+ >=dev-libs/wayland-protocols-1.9
+ media-libs/mesa[wayland,${MULTILIB_USEDEP}]
+ >=x11-libs/libxkbcommon-0.2[${MULTILIB_USEDEP}]
+ )
+ X? (
+ >=app-accessibility/at-spi2-atk-2.5.3[${MULTILIB_USEDEP}]
+ x11-libs/libX11[${MULTILIB_USEDEP}]
+ >=x11-libs/libXi-1.3[${MULTILIB_USEDEP}]
+ x11-libs/libXext[${MULTILIB_USEDEP}]
+ >=x11-libs/libXrandr-1.5[${MULTILIB_USEDEP}]
+ x11-libs/libXcursor[${MULTILIB_USEDEP}]
+ x11-libs/libXfixes[${MULTILIB_USEDEP}]
+ x11-libs/libXcomposite[${MULTILIB_USEDEP}]
+ x11-libs/libXdamage[${MULTILIB_USEDEP}]
+ xinerama? ( x11-libs/libXinerama[${MULTILIB_USEDEP}] )
+ )
+"
+DEPEND="${COMMON_DEPEND}
+ app-text/docbook-xsl-stylesheets
+ app-text/docbook-xml-dtd:4.1.2
+ dev-libs/libxslt
+ dev-libs/gobject-introspection-common
+ >=dev-util/gdbus-codegen-2.48
+ >=dev-util/gtk-doc-am-1.20
+ >=sys-devel/gettext-0.19.7[${MULTILIB_USEDEP}]
+ virtual/pkgconfig[${MULTILIB_USEDEP}]
+ X? (
+ x11-proto/xextproto[${MULTILIB_USEDEP}]
+ x11-proto/xproto[${MULTILIB_USEDEP}]
+ x11-proto/inputproto[${MULTILIB_USEDEP}]
+ x11-proto/damageproto[${MULTILIB_USEDEP}]
+ xinerama? ( x11-proto/xineramaproto[${MULTILIB_USEDEP}] )
+ )
+ test? (
+ media-fonts/font-misc-misc
+ media-fonts/font-cursor-misc )
+"
+# gtk+-3.2.2 breaks Alt key handling in <=x11-libs/vte-0.30.1:2.90
+# gtk+-3.3.18 breaks scrolling in <=x11-libs/vte-0.31.0:2.90
+RDEPEND="${COMMON_DEPEND}
+ >=dev-util/gtk-update-icon-cache-3
+ !<gnome-base/gail-1000
+ !<x11-libs/vte-0.31.0:2.90
+"
+# librsvg for svg icons (PDEPEND to avoid circular dep), bug #547710
+PDEPEND="
+ gnome-base/librsvg[${MULTILIB_USEDEP}]
+ >=x11-themes/adwaita-icon-theme-3.14
+ vim-syntax? ( app-vim/gtk-syntax )
+"
+
+MULTILIB_CHOST_TOOLS=(
+ /usr/bin/gtk-query-immodules-3.0$(get_exeext)
+)
+
+strip_builddir() {
+ local rule=$1
+ shift
+ local directory=$1
+ shift
+ sed -e "s/^\(${rule} =.*\)${directory}\(.*\)$/\1\2/" -i $@ \
+ || die "Could not strip director ${directory} from build."
+}
+
+src_prepare() {
+ if ! use test ; then
+ # don't waste time building tests
+ strip_builddir SRC_SUBDIRS testsuite Makefile.{am,in}
+
+ # the tests dir needs to be build now because since commit
+ # 7ff3c6df80185e165e3bf6aa31bd014d1f8bf224 tests/gtkgears.o needs to be there
+ # strip_builddir SRC_SUBDIRS tests Makefile.{am,in}
+ fi
+
+ if ! use examples; then
+ # don't waste time building demos
+ strip_builddir SRC_SUBDIRS demos Makefile.{am,in}
+ strip_builddir SRC_SUBDIRS examples Makefile.{am,in}
+ fi
+
+ # gtk-update-icon-cache is installed by dev-util/gtk-update-icon-cache
+ eapply "${FILESDIR}"/${PN}-3.22.2-update-icon-cache.patch
+
+ eautoreconf
+ gnome2_src_prepare
+}
+
+multilib_src_configure() {
+ # need libdir here to avoid a double slash in a path that libtool doesn't
+ # grok so well during install (// between $EPREFIX and usr ...)
+ ECONF_SOURCE=${S} \
+ gnome2_src_configure \
+ $(use_enable aqua quartz-backend) \
+ $(use_enable broadway broadway-backend) \
+ $(use_enable cloudprint) \
+ $(use_enable colord) \
+ $(use_enable cups cups auto) \
+ $(multilib_native_use_enable introspection) \
+ $(use_enable wayland wayland-backend) \
+ $(use_enable X x11-backend) \
+ $(use_enable X xcomposite) \
+ $(use_enable X xdamage) \
+ $(use_enable X xfixes) \
+ $(use_enable X xkb) \
+ $(use_enable X xrandr) \
+ $(use_enable xinerama) \
+ --disable-papi \
+ --disable-mir-backend \
+ --enable-man \
+ --with-xml-catalog="${EPREFIX}"/etc/xml/catalog \
+ --libdir="${EPREFIX}"/usr/$(get_libdir) \
+ CUPS_CONFIG="${EPREFIX}/usr/bin/${CHOST}-cups-config"
+
+ # work-around gtk-doc out-of-source brokedness
+ if multilib_is_native_abi; then
+ local d
+ for d in gdk gtk libgail-util; do
+ ln -s "${S}"/docs/reference/${d}/html docs/reference/${d}/html || die
+ done
+ fi
+}
+
+multilib_src_test() {
+ "${EROOT}${GLIB_COMPILE_SCHEMAS}" --allow-any-name "${S}/gtk" || die
+ GSETTINGS_SCHEMA_DIR="${S}/gtk" virtx emake check
+}
+
+multilib_src_install() {
+ gnome2_src_install
+}
+
+multilib_src_install_all() {
+ insinto /etc/gtk-3.0
+ doins "${FILESDIR}"/settings.ini
+ # Skip README.{in,commits,win32} and useless ChangeLog that would get installed by default
+ DOCS=( AUTHORS NEWS README )
+ einstalldocs
+}
+
+pkg_preinst() {
+ gnome2_pkg_preinst
+
+ multilib_pkg_preinst() {
+ # Make immodules.cache belongs to gtk+ alone
+ local cache="usr/$(get_libdir)/gtk-3.0/3.0.0/immodules.cache"
+
+ if [[ -e ${EROOT}${cache} ]]; then
+ cp "${EROOT}"${cache} "${ED}"/${cache} || die
+ else
+ touch "${ED}"/${cache} || die
+ fi
+ }
+ multilib_parallel_foreach_abi multilib_pkg_preinst
+}
+
+pkg_postinst() {
+ gnome2_pkg_postinst
+
+ multilib_pkg_postinst() {
+ gnome2_query_immodules_gtk3 \
+ || die "Update immodules cache failed (for ${ABI})"
+ }
+ multilib_parallel_foreach_abi multilib_pkg_postinst
+
+ if ! has_version "app-text/evince"; then
+ elog "Please install app-text/evince for print preview functionality."
+ elog "Alternatively, check \"gtk-print-preview-command\" documentation and"
+ elog "add it to your settings.ini file."
+ fi
+}
+
+pkg_postrm() {
+ gnome2_pkg_postrm
+
+ if [[ -z ${REPLACED_BY_VERSION} ]]; then
+ multilib_pkg_postrm() {
+ rm -f "${EROOT}"usr/$(get_libdir)/gtk-3.0/3.0.0/immodules.cache
+ }
+ multilib_foreach_abi multilib_pkg_postrm
+ fi
+}